Suds
====

A collection of AMD based classes for rapid JavaScript development.

Suds is not supposed to replace Backbone, Ember or any other sophisticated MVC JavaScript framework. So why was it written at all you ask? Mostly for learing purposes and the fact that it supplies it features in the form of AMD. Thanks to AMD everyone can pick out the little bit you need without adding another 60KB to your project.


Note
----

Suds is very early in development and we can't guarantee that the API won't break.


Dependencies
------------

Suds is depending on [mout](http://moutjs.com) as well as [jQuery](http://jquery.com/).

* The mout packages have to be available via AMD using the base path `mout`. (e.g. `mout/function/bind` or `mout/function/debounce`).

* jQuery should be accessible globally. This can be easily achieved using __requireJS__ buy adding jQuery to the `deps` array in the config settings. _(Note: jQuery is only required in the view class. All other classes are jQuery free)_

Below is an example of a requireJS dev environment setup using __suds__:

```js
require.config( {

	urlArgs: "bust=" +  ( new Date() ).getTime(),

	paths: {
		requireJS: "libs/require/require",
		jquery: "libs/jquery/jquery",
		suds: "libs/suds/source",
		mout: "libs/mout"
	},

	deps: [ "jquery" ]

} );

require( [ "suds/views/View" ], function( View ) {

	var exampleView = new View();

} );

```
