define( [

	"suds/math/Bezier"

], function( Bezier ) {

	describe( "math/Bezier", function() {

		var curce;

		beforeEach( function() {
			curve = new Bezier( 0.1 );

			curve.addAnchor( { x: 0, y: 0 } );
			curve.addAnchor( { x: 0, y: 1 } );
			curve.addAnchor( { x: 1, y: 0 } );
			curve.addAnchor( { x: 1, y: 1 } );
		} );

		it ( "Bezier::goto() jumps to right position in curve", function() {

			curve.setPercent( 0.5 );

			expect( curve.x ).toBe( 0.5 );
			expect( curve.y ).toBe( 0.5 );

		} );

		it ( "Bezier::isComplete() returns true if pointer is at the end of curve", function() {

			curve.setPercent( 1 );

			expect( curve.isComplete() ).toBeTruthy();
		} );

		it ( "Bezier::update()", function() {

			curve.update();
			curve.update();
			curve.update();
			curve.update();
			curve.update();

			expect( curve.x ).toBe( 0.5 );
			expect( curve.y ).toBe( 0.5 );

		} );

	} );

} );