define( [

	"suds/routing/Parser"

], function( Parser ) {

	describe( "routing/Parser", function() {

		var parser;

		beforeEach( function() {

			parser = new Parser();

		} );

		it ( "Parser::match()", function() {

			var a = sinon.spy();
			var b = sinon.spy();
			var c = sinon.spy();

			parser.addRoute( "first/:value/second", a );
			parser.addRoute( "first/*", b );
			parser.addRoute( "third/:value/*", c );

			parser.match( "first/word/second" );

			expect( a.calledOnce ).toBeTruthy();
			expect( a.args[ 0 ][ 0 ][ 0 ] ).toBe( "word" );

			expect( b.calledOnce ).toBeTruthy();

			expect( c.called ).not.toBeTruthy();

		} );

	} );

} );